#ifndef MAIN_COMM_H
#define MAIN_COMM_H

#ifdef __cplusplus
extern "C" {
#endif

#include <stdint.h>

#include "timer_dma.h"
#include "serial_irq.h"

/**
 * Initialization
 */
void comm_init(sirq_t *dbg, sirq_t *bbb, sirq_t *mbed,
               tdma_t *rcv, tdma_t *xmt);

/**
 * Output initialization message init message
 */
void comm_send_sync(uint64_t local);
void comm_send_event(uint16_t event, uint64_t local);

/**
 * Handle init message
 */
void comm_handle_init(header_t *head, init_msg_t *body);
void comm_handle_sync(header_t *head, sync_msg_t *body);
void comm_handle_event(header_t *head, event_msg_t *body);

#ifdef __cplusplus
}
#endif

#endif
